import React from 'react';
import { storiesOf } from '@storybook/react';
import { withKnobs, select, text, boolean } from '@storybook/addon-knobs';
import ButtonGroup from '../ButtonGroup';
import OverflowMenuItem from '../OverflowMenuItem';
var kinds = {
  'Primary button (primary)': 'primary',
  'Secondary button (secondary)': 'secondary',
  'Danger button (danger)': 'danger',
  'Ghost button (ghost)': 'ghost'
};
var sizes = {
  Default: 'default',
  Field: 'field',
  Small: 'small'
};
var props = {
  regular: function regular() {
    return {
      buttonLabel: text('Button Label', 'Button Label'),
      size: select('Button size (size)', sizes, 'default'),
      kind: select('Button kind (kind)', kinds, 'primary'),
      disabled: boolean('Disabled (disabled)', false)
    };
  }
};
storiesOf('ButtonGroup', module).addDecorator(withKnobs).add('Default', function () {
  var regularProps = props.regular();
  return React.createElement(ButtonGroup, regularProps, React.createElement(OverflowMenuItem, {
    itemText: 'Item 1'
  }), React.createElement(OverflowMenuItem, {
    itemText: 'Item 2'
  }), React.createElement(OverflowMenuItem, {
    itemText: 'Item 3'
  }));
}, {
  info: {
    text: "\n        ButtonGroup Component\n        "
  }
});