function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import PropTypes from 'prop-types';
import React, { useState, useRef } from 'react';
import cx from 'classnames';
import Button from '../Button';
import OverflowMenu from '../OverflowMenu';
import { ButtonTypes } from '../../prop-types/types';
import { ChevronDown16 } from '@rocketsoftware/icons-react';
import { settings } from '@rocketsoftware/carbon-components';
var prefix = settings.prefix;

var ButtonGroup = function ButtonGroup(_ref) {
  var children = _ref.children,
      buttonLabel = _ref.buttonLabel,
      disabled = _ref.disabled,
      size = _ref.size,
      kind = _ref.kind;

  var _useState = useState(false),
      _useState2 = _slicedToArray(_useState, 2),
      isOpen = _useState2[0],
      setIsOpen = _useState2[1];

  var buttonRef = useRef(null);

  var getOffset = function getOffset() {
    var _buttonRef$current$ge = buttonRef.current.getBoundingClientRect(),
        top = _buttonRef$current$ge.top;

    return {
      top: top * -1,
      left: 'auto'
    };
  };

  var forOnOpen = function forOnOpen() {
    setIsOpen(true);
  };

  var forOnClose = function forOnClose() {
    setIsOpen(false);
  };

  var iconClasses = cx("".concat(prefix, "--btn-group-icon"), _defineProperty({}, "".concat(prefix, "--btn-group-icon__open"), isOpen));
  return React.createElement("div", {
    "data-floating-menu-container": true,
    ref: buttonRef,
    className: "".concat(prefix, "--btn-group")
  }, React.createElement(OverflowMenu, {
    renderIcon: React.forwardRef(function () {
      return React.createElement(Button, {
        className: iconClasses,
        renderIcon: ChevronDown16,
        kind: kind,
        size: size,
        disabled: disabled
      }, buttonLabel);
    }),
    onOpen: forOnOpen,
    menuOptionsClass: "".concat(prefix, "--overflow-menu-options--container"),
    onClose: forOnClose,
    menuOffset: getOffset,
    disabled: disabled
  }, children));
};

ButtonGroup.propTypes = {
  /**
   * Specify button label
   */
  buttonLabel: PropTypes.string,

  /**
   * Specify button size
   */
  size: PropTypes.oneOf(['default', 'field', 'small']),

  /**
   * Specify button type
   */
  kind: ButtonTypes.buttonKind.isRequired
};
ButtonGroup.defaultProps = {
  kind: 'primary',
  size: 'default'
};
export default ButtonGroup;