function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { storiesOf } from '@storybook/react';
import { action } from '@storybook/addon-actions';
import { withKnobs, boolean, select } from '@storybook/addon-knobs';
import { withA11y } from '@storybook/addon-a11y';
import SplitButton from '../SplitButton';
import OverflowMenuItem from '../OverflowMenuItem';
var sizes = {
  Default: 'default',
  Field: 'field',
  Small: 'small'
};
var props = {
  regular: function regular() {
    return {
      classNameContainer: 'some-class',
      classNameButton: 'some-class',
      classNameOverflow: 'some-class',
      size: select('Button size (size)', sizes, 'default'),
      disabled: boolean('Disabled (disabled)', false)
    };
  },
  items: function items() {
    return {
      onClick: action('onClick')
    };
  }
};
SplitButton.displayName = 'Button';
storiesOf('Button - SplitButton', module).addDecorator(withA11y).addDecorator(withKnobs).add('Default', function () {
  var regularProps = props.regular();
  var itemProps = props.items();
  return React.createElement(SplitButton, regularProps, React.createElement(OverflowMenuItem, _extends({
    itemText: 'Item 1'
  }, itemProps)), React.createElement(OverflowMenuItem, _extends({
    itemText: 'Item 2'
  }, itemProps, {
    primaryFocus: true
  })), React.createElement(OverflowMenuItem, _extends({
    itemText: 'Item 3'
  }, itemProps)), React.createElement(OverflowMenuItem, _extends({
    itemText: 'Item 4'
  }, itemProps)));
}, {
  info: {
    text: "\n        A split button can be used to group a series of actions together into a single location on the screen, providing \n        the user with a single primary action and a small list of alternative actions. \n        "
  }
});