function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

import React from 'react';
import { withKnobs, text, boolean } from '@storybook/addon-knobs';
import TourTooltip from '../TourTooltip';
import { storiesOf } from '@storybook/react';
var props = {
  default: function _default() {
    return {
      title: 'Tooltip Title: Text',
      description: "Lorem ipsum dolor sit amet, \n    consectetur adipiscing elit, \n    sed do eiusmod tempor incididunt ut labore et dolore magna aliqua.",
      onNext: function onNext() {
        return alert('next');
      },
      onPrev: function onPrev() {
        return alert('prev');
      },
      onClose: function onClose() {
        return alert('close');
      }
    };
  }
};
storiesOf('TourTooltip', module).addDecorator(withKnobs).add('default', function () {
  return React.createElement(TourTooltip, props.default());
}).add('custom labels', function () {
  return React.createElement(TourTooltip, _extends({}, props.default(), {
    nextLabel: 'Next Page',
    closeLabel: 'End Tour',
    prevLabel: 'Back'
  }));
}).add('hidden inputs', function () {
  return React.createElement(TourTooltip, _extends({}, props.default(), {
    nextLabel: text('Next label', 'Next Page'),
    closeLabel: text('Close label', 'End Tour'),
    prevLabel: text('Prev label', 'Back'),
    hideClose: boolean('Hide "close" button', true),
    hidePrev: boolean('Hide "previous" button', true),
    hideNext: boolean('Hide "next" button', false),
    hideCheckbox: boolean('Hide checkbox', true),
    checkboxLabel: text('Checkbox label', undefined)
  }));
});