function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

import React from 'react';
import PropTypes from 'prop-types';
import { settings } from '@rocketsoftware/carbon-components';
import Checkbox from '../Checkbox';
var prefix = settings.prefix;

var TourTooltip =
/*#__PURE__*/
function (_React$Component) {
  _inherits(TourTooltip, _React$Component);

  function TourTooltip(props) {
    _classCallCheck(this, TourTooltip);

    return _possibleConstructorReturn(this, _getPrototypeOf(TourTooltip).call(this, props));
  }

  _createClass(TourTooltip, [{
    key: "render",
    value: function render() {
      var _this$props = this.props,
          checked = _this$props.checked,
          onChangeChecked = _this$props.onChangeChecked,
          title = _this$props.title,
          description = _this$props.description,
          nextLabel = _this$props.nextLabel,
          prevLabel = _this$props.prevLabel,
          closeLabel = _this$props.closeLabel,
          onNext = _this$props.onNext,
          onPrev = _this$props.onPrev,
          onClose = _this$props.onClose,
          disableNext = _this$props.disableNext,
          disablePrev = _this$props.disablePrev,
          disableClose = _this$props.disableClose,
          checkboxLabel = _this$props.checkboxLabel,
          hideCheckbox = _this$props.hideCheckbox,
          hideNext = _this$props.hideNext,
          hidePrev = _this$props.hidePrev,
          hideClose = _this$props.hideClose;
      var next = disableNext ? undefined : onNext;
      var prev = disablePrev ? undefined : onPrev;
      var close = disableClose ? undefined : onClose;
      return React.createElement(React.Fragment, null, React.createElement("div", {
        className: "".concat(prefix, "--tour-tooltip")
      }, title && React.createElement("div", {
        className: "".concat(prefix, "--tour-tooltip__heading")
      }, title), React.createElement("p", null, description), !hideCheckbox && React.createElement("div", {
        className: "".concat(prefix, "--tour-tooltip__footer")
      }, React.createElement(Checkbox, {
        id: "".concat(prefix, "--tour-tooltip--checkbox"),
        className: "".concat(prefix, "--tour-tooltip--checkbox"),
        checked: checked,
        onChange: onChangeChecked,
        labelText: checkboxLabel
      })), !(hideNext && hidePrev && hideClose) && React.createElement("div", {
        className: "".concat(prefix, "--tour-tooltip__action-group")
      }, !hideClose && React.createElement("button", {
        onClick: close,
        className: "".concat(prefix, "--btn ").concat(prefix, "--btn--ghost ").concat(prefix, "--btn--sm")
      }, closeLabel), !hidePrev && React.createElement("button", {
        onClick: prev,
        disabled: disablePrev,
        className: "".concat(prefix, "--btn ").concat(prefix, "--btn--secondary ").concat(prefix, "--btn--sm")
      }, prevLabel), !hideNext && React.createElement("button", {
        onClick: next,
        disabled: disableNext,
        className: "".concat(prefix, "--btn ").concat(prefix, "--btn--primary ").concat(prefix, "--btn--sm")
      }, nextLabel))));
    }
  }]);

  return TourTooltip;
}(React.Component);

TourTooltip.propTypes = {
  /**
   * Optional tooltip title
   */
  title: PropTypes.string,

  /**
   * Main tooltip content
   */
  description: PropTypes.string,

  /**
   * Value of the checkbox, if present
   */
  checked: PropTypes.bool,

  /**
   * Callback to fire when the value of the checkbox changes
   */
  onChangeChecked: PropTypes.func,

  /**
   * Optional display text for the "next" button
   */
  nextLabel: PropTypes.string,

  /**
   * Optional display text for the "previous" button
   */
  prevLabel: PropTypes.string,

  /**
   * Optional display text for the "close" button
   */
  closeLabel: PropTypes.string,

  /**
   * Optional display text for the checkbox label
   */
  checkboxLabel: PropTypes.string,

  /**
   * Optionally specify whether the "next"" button should be disabled
   */
  disableNext: PropTypes.bool,

  /**
   * Optionally specify whether the "previous" button should be disabled
   */
  disablePrev: PropTypes.bool,

  /**
   * Optionally specify whether the "close" button should be disabled
   */
  disableClose: PropTypes.bool,

  /**
   * Optionally specify whether the "next"" button should be hidden
   */
  hideNext: PropTypes.bool,

  /**
   * Optionally specify whether the "previous" button should be hidden
   */
  hidePrev: PropTypes.bool,

  /**
   * Optionally specify whether the "close" button should be hidden
   */
  hideClose: PropTypes.bool,

  /**
   * Function to be called when "next" is clicked
   */
  onNext: PropTypes.func,

  /**
   * Function to be called when "prev" is clicked
   */
  onPrev: PropTypes.func,

  /**
   * Function to be called when "close" is clicked
   */
  onClose: PropTypes.func,

  /**
   * Optionally hide the checkbox
   */
  hideCheckbox: PropTypes.bool,

  /**
   * Optionally provide the initial state of checkbox
   */
  initialCheckboxValue: PropTypes.bool
};
TourTooltip.defaultProps = {
  nextLabel: 'Next',
  prevLabel: 'Previous',
  closeLabel: 'Skip',
  checkboxLabel: "Don't show tour again.",
  hideNext: false,
  hidePrev: false,
  hideClose: false
};
export default TourTooltip;