"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _addonActions = require("@storybook/addon-actions");

var _addonKnobs = require("@storybook/addon-knobs");

var _addonA11y = require("@storybook/addon-a11y");

var _SplitButton = _interopRequireDefault(require("../SplitButton"));

var _OverflowMenuItem = _interopRequireDefault(require("../OverflowMenuItem"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

var sizes = {
  Default: 'default',
  Field: 'field',
  Small: 'small'
};
var props = {
  regular: function regular() {
    return {
      classNameContainer: 'some-class',
      classNameButton: 'some-class',
      classNameOverflow: 'some-class',
      size: (0, _addonKnobs.select)('Button size (size)', sizes, 'default'),
      disabled: (0, _addonKnobs.boolean)('Disabled (disabled)', false)
    };
  },
  items: function items() {
    return {
      onClick: (0, _addonActions.action)('onClick')
    };
  }
};
_SplitButton.default.displayName = 'Button';
(0, _react2.storiesOf)('Button - SplitButton', module).addDecorator(_addonA11y.withA11y).addDecorator(_addonKnobs.withKnobs).add('Default', function () {
  var regularProps = props.regular();
  var itemProps = props.items();
  return _react.default.createElement(_SplitButton.default, regularProps, _react.default.createElement(_OverflowMenuItem.default, _extends({
    itemText: 'Item 1'
  }, itemProps)), _react.default.createElement(_OverflowMenuItem.default, _extends({
    itemText: 'Item 2'
  }, itemProps, {
    primaryFocus: true
  })), _react.default.createElement(_OverflowMenuItem.default, _extends({
    itemText: 'Item 3'
  }, itemProps)), _react.default.createElement(_OverflowMenuItem.default, _extends({
    itemText: 'Item 4'
  }, itemProps)));
}, {
  info: {
    text: "\n        A split button can be used to group a series of actions together into a single location on the screen, providing \n        the user with a single primary action and a small list of alternative actions. \n        "
  }
});