"use strict";

var _react = _interopRequireDefault(require("react"));

var _react2 = require("@storybook/react");

var _addonKnobs = require("@storybook/addon-knobs");

var _Tour = _interopRequireDefault(require("../Tour"));

var _Button = _interopRequireDefault(require("../Button"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var targets = _react.default.createElement(_react.default.Fragment, null, _react.default.createElement("div", {
  id: "one",
  style: {
    position: 'absolute',
    left: 20,
    top: 20,
    background: 'magenta',
    width: 40,
    height: 40
  }
}), _react.default.createElement(_Button.default, {
  id: "two",
  style: {
    position: 'relative',
    left: 200
  }
}, "I am a button!"), _react.default.createElement("div", {
  id: "three",
  style: {
    position: 'absolute',
    left: 20,
    top: 1800,
    background: 'orange',
    width: 40,
    height: 40
  }
}));

var steps = {
  default: function _default() {
    return [{
      selector: '#one',
      title: 'Welcome To The Tour',
      description: 'Use this component to point out new or important features.'
    }, {
      selector: '#two',
      movingTarget: true,
      description: 'You can interact with the elements being highlighted.'
    }];
  },
  scroll: function scroll() {
    return [{
      selector: '#one',
      title: 'Welcome To The Tour',
      description: 'Use this component to point out new or important features.'
    }, {
      selector: '#three',
      description: 'You can scroll to ofscreen elements'
    }];
  }
};
(0, _react2.storiesOf)('Tour', module).add('default', function () {
  return _react.default.createElement(_react.default.Fragment, null, targets, _react.default.createElement(_Tour.default, {
    steps: steps.default()
  }));
}).add('no mask', function () {
  return _react.default.createElement(_react.default.Fragment, null, targets, _react.default.createElement(_Tour.default, {
    steps: steps.default(),
    disableMask: true
  }));
}).addDecorator(_addonKnobs.withKnobs).add('with scrolling', function () {
  return _react.default.createElement(_react.default.Fragment, null, targets, _react.default.createElement(_Tour.default, {
    steps: steps.scroll(),
    disableAutoScroll: (0, _addonKnobs.boolean)('disable auto scroll', false),
    disableSmoothScroll: (0, _addonKnobs.boolean)('disable smooth scroll', false)
  }));
}).add('hide buttons', function () {
  return _react.default.createElement(_react.default.Fragment, null, targets, _react.default.createElement(_Tour.default, {
    steps: steps.default(),
    hideClose: true,
    hidePrev: true,
    hideNext: true
  }));
});