"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = _interopRequireDefault(require("react"));

var _walktour = require("walktour");

var _TourTooltip = _interopRequireDefault(require("../TourTooltip"));

var _propTypes = _interopRequireDefault(require("prop-types"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _extends() { _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

var Tour =
/*#__PURE__*/
function (_React$Component) {
  _inherits(Tour, _React$Component);

  function Tour(props) {
    var _this;

    _classCallCheck(this, Tour);

    _this = _possibleConstructorReturn(this, _getPrototypeOf(Tour).call(this, props));
    _this.state = {
      checked: false
    };
    return _this;
  }

  _createClass(Tour, [{
    key: "render",
    value: function render() {
      var _this2 = this;

      return _react.default.createElement(_walktour.Walktour, _extends({}, this.props, {
        customTooltipRenderer: function customTooltipRenderer(logic) {
          var _logic$stepContent = logic.stepContent,
              title = _logic$stepContent.title,
              description = _logic$stepContent.description,
              disableClose = _logic$stepContent.disableClose,
              disableNext = _logic$stepContent.disableNext,
              disablePrev = _logic$stepContent.disablePrev,
              nextLabel = _logic$stepContent.nextLabel,
              prevLabel = _logic$stepContent.prevLabel,
              closeLabel = _logic$stepContent.closeLabel;
          var onClose = _this2.props.onClose ? function () {
            _this2.props.onClose(_this2.state.checked);

            logic.close();
          } : logic.close;
          return _react.default.createElement(_TourTooltip.default, _extends({
            onChangeChecked: function onChangeChecked(val) {
              return _this2.setState({
                checked: val
              });
            },
            checked: _this2.state.checked
          }, _this2.props, {
            onNext: logic.next,
            onPrev: logic.prev,
            onClose: onClose,
            description: description,
            title: title,
            disableClose: disableClose,
            disableNext: disableNext,
            disablePrev: disablePrev,
            nextLabel: nextLabel,
            prevLabel: prevLabel,
            closeLabel: closeLabel
          }));
        }
      }));
    }
  }]);

  return Tour;
}(_react.default.Component);

exports.default = Tour;
Tour.propTypes = {
  /**
   * An array of steps that the tour should follow
   */
  steps: _propTypes.default.arrayOf(_propTypes.default.shape({
    selector: _propTypes.default.string,
    description: _propTypes.default.string.isRequired,
    title: _propTypes.default.string,
    nextLabel: _propTypes.default.string,
    prevLabel: _propTypes.default.string,
    closeLabel: _propTypes.default.string,
    disableNext: _propTypes.default.bool,
    disablePrev: _propTypes.default.bool,
    disableClose: _propTypes.default.bool,
    customNextFunc: _propTypes.default.func,
    customPrevFunc: _propTypes.default.func,
    customCloseFunc: _propTypes.default.func
  })).isRequired,

  /** Optionally specify a custom close function for the entire tour. The checkbox state is passed as an argument to the callback
   *
   */
  onClose: _propTypes.default.func,

  /**
   * Optionally specify whether the tour should watch for changes to the target's size or position.
   */
  movingTarget: _propTypes.default.bool,

  /**
   * Optional identifier to differentiate between multiple tours on the same page.
   */
  identifier: _propTypes.default.string,

  /**
   * Optionally specify whether the mask should be disabled
   */
  disableMask: _propTypes.default.bool,

  /**
   * Optionally disable automatic scrolling
   */
  disableAutoScroll: _propTypes.default.bool,

  /**
   * Optionally provide a callback that handles receiving an update function. Can be used to listen
   * for events and recalculate the tour's position when those events fire. The callback will be
   * passed `update` as an argument.
   */
  setUpdateListener: _propTypes.default.func,

  /**
   * Optionally provide a callback intended to remove the listener set by `setUpdateListener`.
   * The callback will be passed `update` as an argument. Should only and always be used with `setUpdateListener`.
   */
  removeUpdateListener: _propTypes.default.func,

  /**
   * Optionally specify whether the tour is active or not. If specified, the tour will act as
   * a controlled component, and will defer to this prop when closing.
   */
  isOpen: _propTypes.default.bool,

  /**
   * Optionally specify whether the "next"" button should be hidden
   */
  hideNext: _propTypes.default.bool,

  /**
   * Optionally specify whether the "previous" button should be hidden
   */
  hidePrev: _propTypes.default.bool,

  /**
   * Optionally specify whether the "close" button should be hidden
   */
  hideClose: _propTypes.default.bool
};